"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Configstore = require("configstore");
var googleapis_1 = require("googleapis");
var http = require("http");
var open = require("open");
var CONFIGSTORE_NAME = 'create_firebase';
var CALLBACK_SERVER = {
    HOST: 'localhost',
    PORT: 9005,
    URL: "http://localhost:9005"
};
var OAUTH = {
    CLIENT_ID: '514670030483-l26u9lmdeidnfdfid3cfmjiu3p84r9ea.apps.googleusercontent.com',
    CLIENT_SECRET: 'esSSrnwU2_CVBkSUd9zaZC80',
    SCOPE: ['https://www.googleapis.com/auth/cloud-platform', 'https://www.googleapis.com/auth/firebase']
};
exports.oauth2Client = new googleapis_1.google.auth.OAuth2(OAUTH.CLIENT_ID, OAUTH.CLIENT_SECRET, CALLBACK_SERVER.URL);
var conf = new Configstore(CONFIGSTORE_NAME);
(function credentialManager() {
    var storedCred = conf.get('tokens');
    if (storedCred) {
        exports.oauth2Client.credentials = storedCred;
        exports.oauth2Client.setCredentials(storedCred);
    }
    exports.oauth2Client.on('tokens', function (tokens) {
        conf.set('tokens', tokens);
    });
})();
function getGoogleAuthCode() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    var timeout;
                    var url = exports.oauth2Client.generateAuthUrl({
                        access_type: 'offline',
                        scope: OAUTH.SCOPE
                    });
                    console.info('Waiting for authentication...\n');
                    console.info(url, '\n');
                    open(url);
                    var server = http
                        .createServer(function (req, res) {
                        if (req.url) {
                            req.connection.ref();
                            if (req.url.includes('error=')) {
                                reject('User declined authentication');
                            }
                            resolve(decodeURIComponent(req.url.slice(7, 96)));
                            clearTimeout(timeout);
                            res.end(function () { return req.connection.unref(); });
                            server.close();
                        }
                    })
                        .listen(CALLBACK_SERVER.PORT)
                        .on('connection', function (socket) { return socket.unref(); });
                    timeout = setTimeout(function () {
                        reject('Timed out waiting for user authentication.');
                        server.close();
                    }, 60000);
                })];
        });
    });
}
function authenticate(verbose) {
    if (verbose === void 0) { verbose = false; }
    return __awaiter(this, void 0, void 0, function () {
        var authorizationCode, tokens;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!exports.oauth2Client.credentials.refresh_token) return [3 /*break*/, 1];
                    verbose && console.info('You are already logged in. \n');
                    return [3 /*break*/, 4];
                case 1: return [4 /*yield*/, getGoogleAuthCode()];
                case 2:
                    authorizationCode = _a.sent();
                    return [4 /*yield*/, exports.oauth2Client.getToken(authorizationCode)];
                case 3:
                    tokens = (_a.sent()).tokens;
                    exports.oauth2Client.credentials = tokens;
                    exports.oauth2Client.setCredentials(tokens);
                    verbose && console.log('You are now logged in. \n');
                    _a.label = 4;
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.authenticate = authenticate;
function deauthenticate(verbose) {
    if (verbose === void 0) { verbose = false; }
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!exports.oauth2Client.credentials.access_token) return [3 /*break*/, 2];
                    conf.delete('tokens');
                    return [4 /*yield*/, exports.oauth2Client.revokeCredentials()];
                case 1:
                    _a.sent();
                    verbose && console.info('You are now logged out. \n');
                    return [3 /*break*/, 3];
                case 2:
                    verbose && console.info('You are already logged out. \n');
                    _a.label = 3;
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.deauthenticate = deauthenticate;
//# sourceMappingURL=auth.js.map