#!/usr/bin/env node
"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var cli_spinner_1 = require("cli-spinner");
var _1 = require(".");
var auth_1 = require("./auth");
var util_1 = require("./util");
var program = new util_1.CLI();
cli_spinner_1.Spinner.setDefaultSpinnerString(18);
var spinner = new cli_spinner_1.Spinner();
function handleProgress(event, data) {
    if (!spinner.isSpinning()) {
        spinner.start();
    }
    switch (event) {
        case _1.EVENTS.PROJECT_CREATION_ATTEMPT_STARTED:
            spinner.setSpinnerTitle("Attempting to claim " + data);
            break;
        case _1.EVENTS.PROJECT_CREATION_STARTED:
            spinner.setSpinnerTitle("Provisioning " + data);
            break;
        case _1.EVENTS.PROJECT_CREATION_SUCCEEDED:
            spinner.setSpinnerTitle("Finished creating " + data);
            break;
        case _1.EVENTS.ADD_FIREBASE_FEATURES_STARTED:
            spinner.setSpinnerTitle('Setting up Firebase features');
            break;
        case _1.EVENTS.ADD_FIREBASE_FEATURES_SUCCEEDED:
            spinner.stop(true);
            break;
    }
}
program
    .command('create <name=new-firebase-project>(New project name)')
    .description('Create a project')
    .action(function (_a) {
    var name = _a.name;
    return __awaiter(void 0, void 0, void 0, function () {
        var projectId;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, auth_1.authenticate()];
                case 1:
                    _b.sent();
                    return [4 /*yield*/, _1.createFirebaseProject(name, handleProgress)];
                case 2:
                    projectId = _b.sent();
                    console.log("Successfully created new firebase project: " + projectId);
                    return [2 /*return*/];
            }
        });
    });
});
program
    .command('list [filter=firebase,gcp,all](Filter by project type [firebase, gcp, all])')
    .description('List projects')
    .action(function (_a) {
    var filter = _a.filter;
    return __awaiter(void 0, void 0, void 0, function () {
        var listFirebase, listGCP, sources, nested, data;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, auth_1.authenticate()];
                case 1:
                    _b.sent();
                    listFirebase = ['firebase', 'all'].includes(filter) || undefined;
                    listGCP = ['gcp', 'all'].includes(filter) || undefined;
                    sources = [listFirebase && _1.listFirebaseProjects(), listGCP && _1.listAvailableProjects()];
                    return [4 /*yield*/, Promise.all(sources)];
                case 2:
                    nested = _b.sent();
                    data = (nested.reduce(function (prev, curr) {
                        if (prev === void 0) { prev = []; }
                        if (curr === void 0) { curr = []; }
                        curr = curr.map(function (project) {
                            return __assign(__assign({}, project), { projectId: project.projectId || project.project });
                        });
                        return prev.concat(curr);
                    }) || []);
                    data.forEach(function (project) {
                        var projectId = project.projectId, displayName = project.displayName;
                        var projectName = displayName || projectId || '';
                        var line = projectName + " " + chalk_1.default.grey("(" + projectId + ")");
                        console.log(line);
                    });
                    return [2 /*return*/];
            }
        });
    });
});
program
    .command('add-webapp <name>(Name of new webapp) [parent](Parent project-id of new webapp)')
    .description('Create a webapp')
    .action(function (_a) {
    var name = _a.name, parent = _a.parent;
    return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, auth_1.authenticate()];
                case 1:
                    _b.sent();
                    return [4 /*yield*/, _1.createFirebaseWebapp(parent, name)];
                case 2:
                    _b.sent();
                    console.log("New webapp " + name + " was created for " + parent);
                    return [2 /*return*/];
            }
        });
    });
});
program
    .command('login')
    .description('Login')
    .action(function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, auth_1.authenticate(true)];
            case 1:
                _a.sent();
                program.run();
                return [2 /*return*/];
        }
    });
}); });
program
    .command('logout')
    .description('Logout')
    .action(function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, auth_1.deauthenticate(true)];
            case 1:
                _a.sent();
                program.run();
                return [2 /*return*/];
        }
    });
}); });
program.root().title('What would you like to do?');
program.root().run();
//# sourceMappingURL=cli.js.map