"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var firebase_types_1 = require("./firebase.types");
var util_1 = require("./util");
function getFirebaseWebappConfig(googleapis, projectId, appId) {
    return __awaiter(this, void 0, void 0, function () {
        var isFullPath, name, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    isFullPath = projectId.includes('/');
                    name = isFullPath ? projectId + "/config" : "projects/" + projectId + "/webApps/" + appId + "/config";
                    return [4 /*yield*/, googleapis.firebase.projects.webApps.getConfig({ name: name })];
                case 1:
                    data = (_a.sent()).data;
                    return [2 /*return*/, data];
            }
        });
    });
}
exports.getFirebaseWebappConfig = getFirebaseWebappConfig;
function getFirebaseWebapp(googleapis, projectId, appId) {
    return __awaiter(this, void 0, void 0, function () {
        var isFullPath, name, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    isFullPath = projectId.includes('/');
                    name = isFullPath ? projectId : "projects/" + projectId + "/webApps/" + appId;
                    return [4 /*yield*/, googleapis.firebase.projects.webApps.get({ name: name })];
                case 1:
                    data = (_a.sent()).data;
                    return [2 /*return*/, data];
            }
        });
    });
}
exports.getFirebaseWebapp = getFirebaseWebapp;
function createFirebaseWebapp(googleapis, projectId, displayName, appUrls) {
    return __awaiter(this, void 0, void 0, function () {
        var parent, appRequest, operation, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    parent = "projects/" + projectId;
                    appRequest = { parent: parent, requestBody: { displayName: displayName, appUrls: appUrls } };
                    return [4 /*yield*/, googleapis.firebase.projects.webApps.create(appRequest)];
                case 1:
                    operation = _a.sent();
                    return [4 /*yield*/, util_1.waitOnOperation(googleapis.firebase, operation)];
                case 2:
                    data = _a.sent();
                    return [2 /*return*/, data.response];
            }
        });
    });
}
exports.createFirebaseWebapp = createFirebaseWebapp;
function listFirebaseProjectApps(googleapis, projectId, pageSize, pageToken) {
    return __awaiter(this, void 0, void 0, function () {
        var parent, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    parent = "projects/" + projectId;
                    return [4 /*yield*/, googleapis.firebase.projects.searchApps({ pageSize: pageSize, pageToken: pageToken, parent: parent })];
                case 1:
                    data = (_a.sent()).data;
                    return [2 /*return*/, data.apps];
            }
        });
    });
}
exports.listFirebaseProjectApps = listFirebaseProjectApps;
function getFirebaseProject(googleapis, projectId) {
    return __awaiter(this, void 0, void 0, function () {
        var name, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    name = "projects/" + projectId;
                    return [4 /*yield*/, googleapis.firebase.projects.get({ name: name })];
                case 1:
                    data = (_a.sent()).data;
                    return [2 /*return*/, data];
            }
        });
    });
}
exports.getFirebaseProject = getFirebaseProject;
function listAvailableProjects(googleapis, pageSize, pageToken) {
    return __awaiter(this, void 0, void 0, function () {
        var data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, googleapis.firebase.availableProjects.list({ pageSize: pageSize, pageToken: pageToken })];
                case 1:
                    data = (_a.sent()).data;
                    return [2 /*return*/, data.projectInfo];
            }
        });
    });
}
exports.listAvailableProjects = listAvailableProjects;
function listFirebaseProjects(googleapis, pageSize, pageToken) {
    return __awaiter(this, void 0, void 0, function () {
        var data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, googleapis.firebase.projects.list({ pageSize: pageSize, pageToken: pageToken })];
                case 1:
                    data = (_a.sent()).data;
                    return [2 /*return*/, data.results || []];
            }
        });
    });
}
exports.listFirebaseProjects = listFirebaseProjects;
function createFirebaseProject(googleapis, name, cb) {
    if (cb === void 0) { cb = util_1.noop; }
    return __awaiter(this, void 0, void 0, function () {
        var projectId;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, createGCProject(googleapis, name, cb)];
                case 1:
                    projectId = _a.sent();
                    return [4 /*yield*/, addFirebaseFeatures(googleapis, projectId, cb)];
                case 2:
                    _a.sent();
                    return [2 /*return*/, projectId];
            }
        });
    });
}
exports.createFirebaseProject = createFirebaseProject;
function addFirebaseFeatures(googleapis, projectId, cb) {
    if (cb === void 0) { cb = util_1.noop; }
    return __awaiter(this, void 0, void 0, function () {
        var project, operation;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    project = "projects/" + projectId;
                    cb(firebase_types_1.EVENTS.ADD_FIREBASE_FEATURES_STARTED);
                    return [4 /*yield*/, googleapis.firebase.projects.addFirebase({ project: project })];
                case 1:
                    operation = _a.sent();
                    return [4 /*yield*/, util_1.waitOnOperation(googleapis.firebase, operation)];
                case 2:
                    _a.sent();
                    cb(firebase_types_1.EVENTS.ADD_FIREBASE_FEATURES_SUCCEEDED);
                    return [2 /*return*/];
            }
        });
    });
}
exports.addFirebaseFeatures = addFirebaseFeatures;
function createGCProject(googleapis, name, cb) {
    if (cb === void 0) { cb = util_1.noop; }
    return __awaiter(this, void 0, void 0, function () {
        var projectIdBase;
        return __generator(this, function (_a) {
            projectIdBase = name
                .replace(/\s/g, '-') /* replace whitespace with dashes */
                .replace(/[^A-z0-9\-]|\[|\]|\^|\_|\`|\\/g, '') /* Remove all non-alphanumeric characters */
                .toLowerCase();
            return [2 /*return*/, (function attemptCreate(randSuffix) {
                    if (randSuffix === void 0) { randSuffix = ''; }
                    return __awaiter(this, void 0, void 0, function () {
                        var projectId, request, operation, data, e_1;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    projectId = randSuffix ? projectIdBase + "-" + randSuffix : projectIdBase;
                                    cb(firebase_types_1.EVENTS.PROJECT_CREATION_ATTEMPT_STARTED, projectId);
                                    _a.label = 1;
                                case 1:
                                    _a.trys.push([1, 4, , 5]);
                                    request = { requestBody: { projectId: projectId, name: name } };
                                    return [4 /*yield*/, googleapis.cloudresourcemanager.projects.create(request)];
                                case 2:
                                    operation = _a.sent();
                                    cb(firebase_types_1.EVENTS.PROJECT_CREATION_STARTED, projectId);
                                    return [4 /*yield*/, util_1.waitOnOperation(googleapis.cloudresourcemanager, operation)];
                                case 3:
                                    data = _a.sent();
                                    cb(firebase_types_1.EVENTS.PROJECT_CREATION_SUCCEEDED, projectId);
                                    return [2 /*return*/, data.response.projectId];
                                case 4:
                                    e_1 = _a.sent();
                                    if (e_1.message === firebase_types_1.ERRORS.PROJECTID_TAKEN) {
                                        cb(firebase_types_1.EVENTS.PROJECT_CREATION_NAME_TAKEN, projectId);
                                        return [2 /*return*/, attemptCreate(randSuffix + util_1.getRandomHexLen(4))];
                                    }
                                    else {
                                        throw e_1;
                                    }
                                    return [3 /*break*/, 5];
                                case 5: return [2 /*return*/];
                            }
                        });
                    });
                })()];
        });
    });
}
exports.createGCProject = createGCProject;
//# sourceMappingURL=firebase.js.map