import { GaxiosResponse } from 'gaxios';
import { cloudresourcemanager_v1, firebase_v1beta1 } from 'googleapis';
import { CloudResourceManagerApi, FirebaseApi } from './apis.types';
export declare const noop: () => undefined;
export declare type ShiftArgs<T> = T extends (arg0: any, ...args: infer R) => any ? R : never;
export declare type DeepPartial<T> = {
    [P in keyof T]?: T[P] extends Array<infer U> ? Array<DeepPartial<U>> : T[P] extends ReadonlyArray<infer R> ? ReadonlyArray<DeepPartial<R>> : DeepPartial<T[P]>;
};
declare type FirebaseOperation = firebase_v1beta1.Schema$Operation;
declare type CloudResourceManagerOperation = cloudresourcemanager_v1.Schema$Operation;
export declare function waitOnOperation(api: CloudResourceManagerApi | FirebaseApi, operation: GaxiosResponse<cloudresourcemanager_v1.Schema$Operation>): Promise<CloudResourceManagerOperation | FirebaseOperation>;
export declare function getRandomHexLen(length: number): string;
export declare class CLI {
    private args;
    private initialRun;
    private prog;
    private isInteractive;
    private currentCmdPathStr;
    private currentCommand;
    private currentCommandArgs;
    private inquirerConfig;
    run(): Promise<void>;
    command(commandStr: string): this;
    menu(menuName: string): this;
    root(): this;
    description(description: string): this;
    title(title: string): this;
    action(fn: (...args: any[]) => any): this;
    private parseCommandString;
    private getParentCmdPath;
    private formalizeCommandTree;
}
export {};
