"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var chai = require("chai");
var mocha = require("mocha");
var sinon = require("sinon");
var firebase_1 = require("../src/firebase");
var firebase_types_1 = require("../src/firebase.types");
var describe = mocha.describe, it = mocha.it;
var expect = chai.expect, assert = chai.assert;
var APIStub = /** @class */ (function () {
    function APIStub() {
        var _this = this;
        this.defaultResponse = {
            config: {},
            data: {},
            headers: {},
            status: 200,
            statusText: 'OK'
        };
        this.resolveTicks = 0;
        this.cloudresourcemanager$operations$get$throw = {
            message: '',
            remaining: 0
        };
        this.cloudresourcemanager$operations$get$response = __assign(__assign({}, this.defaultResponse), { data: { done: true, response: { projectId: '' } } });
        this.cloudresourcemanager$projects$create$throw = {
            message: '',
            remaining: 0
        };
        this.cloudresourcemanager$projects$create$response = __assign(__assign({}, this.defaultResponse), { data: { name: '' } });
        this.cloudresourcemanager = {
            operations: {
                get: function () {
                    if (_this.cloudresourcemanager$operations$get$throw.remaining > 0) {
                        _this.cloudresourcemanager$operations$get$throw.remaining--;
                        throw new Error(_this.cloudresourcemanager$operations$get$throw.message);
                    }
                    return new Promise(function (res) {
                        return setTimeout(function () {
                            res(__assign({}, _this.cloudresourcemanager$operations$get$response));
                        }, _this.resolveTicks);
                    });
                }
            },
            projects: {
                create: function (request) {
                    var projectId = request.requestBody.projectId;
                    if (_this.cloudresourcemanager$projects$create$throw.remaining > 0) {
                        _this.cloudresourcemanager$projects$create$throw.remaining--;
                        throw new Error(_this.cloudresourcemanager$projects$create$throw.message);
                    }
                    _this.cloudresourcemanager$projects$create$response.data.name = "operations/" + projectId;
                    _this.cloudresourcemanager$operations$get$response.data.response.projectId = projectId;
                    return new Promise(function (res) {
                        return setTimeout(function () {
                            res(__assign({}, _this.cloudresourcemanager$projects$create$response));
                        }, _this.resolveTicks);
                    });
                }
            }
        };
        this.firebase$operations$get$throw = {
            message: '',
            remaining: 0
        };
        this.firebase$operations$get$response = __assign(__assign({}, this.defaultResponse), { data: { done: true, response: { projectId: '' } } });
        this.firebase$projects$addFirebase$throw = {
            message: '',
            remaining: 0
        };
        this.firebase$projects$addFirebase$response = __assign(__assign({}, this.defaultResponse), { data: { name: '' } });
        this.firebase = {
            operations: {
                get: function () {
                    if (_this.firebase$operations$get$throw.remaining > 0) {
                        _this.firebase$operations$get$throw.remaining--;
                        throw new Error(_this.firebase$operations$get$throw.message);
                    }
                    return new Promise(function (res) {
                        return setTimeout(function () {
                            res(__assign({}, _this.firebase$operations$get$response));
                        }, _this.resolveTicks);
                    });
                }
            },
            projects: {
                addFirebase: function (request) {
                    var projectName = request.project;
                    if (_this.firebase$projects$addFirebase$throw.remaining > 0) {
                        _this.firebase$projects$addFirebase$throw.remaining--;
                        throw new Error(_this.firebase$projects$addFirebase$throw.message);
                    }
                    _this.firebase$projects$addFirebase$response.data.name = "operations/" + projectName;
                    _this.firebase$operations$get$response.data.response.projectId = projectName;
                    return new Promise(function (res) {
                        return setTimeout(function () {
                            res(__assign({}, _this.firebase$projects$addFirebase$response));
                        }, _this.resolveTicks);
                    });
                }
            }
        };
    }
    return APIStub;
}());
describe('Cloud Resource Manager', function () {
    var _this = this;
    this.timeout(0);
    describe('createGCProject', function () {
        it('successfully creates project with unique name', function () { return __awaiter(_this, void 0, void 0, function () {
            var api, projectName, callback, projectId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        api = new APIStub();
                        projectName = 'test';
                        callback = sinon.fake();
                        return [4 /*yield*/, firebase_1.createGCProject(api, projectName, callback)];
                    case 1:
                        projectId = _a.sent();
                        assert.isTrue(callback.calledWith(firebase_types_1.EVENTS.PROJECT_CREATION_ATTEMPT_STARTED, projectName));
                        assert.isTrue(callback.calledWith(firebase_types_1.EVENTS.PROJECT_CREATION_STARTED, projectName));
                        assert.isTrue(callback.calledWith(firebase_types_1.EVENTS.PROJECT_CREATION_SUCCEEDED, projectName));
                        expect(projectId).equals(projectName);
                        return [2 /*return*/];
                }
            });
        }); });
        it('generates a unique projectId if provided name is taken', function () { return __awaiter(_this, void 0, void 0, function () {
            var _a, _b, numFails, api, projectName, callback, projectId, _c, name_1, randSuffix, e_1_1;
            var e_1, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _e.trys.push([0, 5, 6, 7]);
                        _a = __values([1, 2, 4]), _b = _a.next();
                        _e.label = 1;
                    case 1:
                        if (!!_b.done) return [3 /*break*/, 4];
                        numFails = _b.value;
                        api = new APIStub();
                        api.cloudresourcemanager$projects$create$throw.message = firebase_types_1.ERRORS.PROJECTID_TAKEN;
                        api.cloudresourcemanager$projects$create$throw.remaining = numFails;
                        projectName = 'test';
                        callback = sinon.fake();
                        return [4 /*yield*/, firebase_1.createGCProject(api, projectName, callback)];
                    case 2:
                        projectId = _e.sent();
                        _c = __read(projectId.split('-'), 2), name_1 = _c[0], randSuffix = _c[1];
                        expect(name_1).equals(projectName);
                        expect(randSuffix.length).equals(numFails * 4);
                        assert.isTrue(callback.calledWith(firebase_types_1.EVENTS.PROJECT_CREATION_NAME_TAKEN));
                        _e.label = 3;
                    case 3:
                        _b = _a.next();
                        return [3 /*break*/, 1];
                    case 4: return [3 /*break*/, 7];
                    case 5:
                        e_1_1 = _e.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 7];
                    case 6:
                        try {
                            if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 7: return [2 /*return*/];
                }
            });
        }); });
        it('throws unhandled errors to caller', function () { return __awaiter(_this, void 0, void 0, function () {
            var errorMessage, api, e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        errorMessage = 'not specially handled';
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        api = new APIStub();
                        api.cloudresourcemanager$projects$create$throw.message = errorMessage;
                        api.cloudresourcemanager$projects$create$throw.remaining = 1;
                        return [4 /*yield*/, firebase_1.createGCProject(api, '')];
                    case 2:
                        _a.sent();
                        assert.fail('Arbitrary errors should not be caught in createCGProject');
                        return [3 /*break*/, 4];
                    case 3:
                        e_2 = _a.sent();
                        expect(e_2.message).equals(errorMessage, 'Errors is passed through as-is');
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
    });
});
describe('Firebase', function () {
    var _this = this;
    this.timeout(0);
    describe('addFirebaseFeatures', function () {
        it('successfully adds firebase features to an existing project', function () { return __awaiter(_this, void 0, void 0, function () {
            var api, projectName, callback;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        api = new APIStub();
                        projectName = 'test-project';
                        callback = sinon.fake();
                        return [4 /*yield*/, firebase_1.addFirebaseFeatures(api, projectName, callback)];
                    case 1:
                        _a.sent();
                        assert.isTrue(callback.calledWith(firebase_types_1.EVENTS.ADD_FIREBASE_FEATURES_STARTED), 'operation was started and callback was invoked');
                        assert.isTrue(callback.calledWith(firebase_types_1.EVENTS.ADD_FIREBASE_FEATURES_SUCCEEDED), 'operation succeeded and callback was invoked');
                        return [2 /*return*/];
                }
            });
        }); });
        it('throws when addFirebase API Call fails', function () { return __awaiter(_this, void 0, void 0, function () {
            var errorMessage, projectName, callback, api, e_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        errorMessage = 'unhandled error';
                        projectName = 'test-project';
                        callback = sinon.fake();
                        api = new APIStub();
                        api.firebase$projects$addFirebase$throw.message = errorMessage;
                        api.firebase$projects$addFirebase$throw.remaining = 1;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, firebase_1.addFirebaseFeatures(api, projectName, callback)];
                    case 2:
                        _a.sent();
                        assert.fail('Errors should not be caught by addFirebaseFeatures');
                        return [3 /*break*/, 4];
                    case 3:
                        e_3 = _a.sent();
                        expect(e_3.message).equals(errorMessage, 'Error is passed through as-is');
                        assert.isTrue(callback.calledWith(firebase_types_1.EVENTS.ADD_FIREBASE_FEATURES_STARTED), 'operation was started and callback was invoked');
                        assert.isFalse(callback.calledWith(firebase_types_1.EVENTS.ADD_FIREBASE_FEATURES_SUCCEEDED), 'operation did not succeed and callback was not invoked');
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
    });
    describe('createFirebaseProject', function () {
        it('creates a new GC Project and adds Firebase features', function () { return __awaiter(_this, void 0, void 0, function () {
            var projectName, callback, api, projectId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        projectName = 'test-project';
                        callback = sinon.fake();
                        api = new APIStub();
                        return [4 /*yield*/, firebase_1.createFirebaseProject(api, projectName, callback)];
                    case 1:
                        projectId = _a.sent();
                        expect(projectId).equals(projectName);
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=test.spec.js.map